// Библиотека для работы с протоколом I2C (порты A5/SCL и A4/SDA)
#include <Wire.h>
#include "constants.h"
#include "gyro_acsel.h"
//начальное смещение нуля баланса.
#include "conscious_movement.h"
#include "step_motor5.h"
#include "stepcoder.h"

bool flagStop;
void setup()
{
  // Заносим в переменные номера контактов (пинов) Arduino.
  // Для левых и правых моторов машинки.//
  setup_step_motor(); //Инициализирую шаговый мотор
  // Двигатели остановлены.
  digitalWrite(EN, 1); // Пока отключен
  giroscop_setup();

  pinMode(S_DIOD, OUTPUT);
  delay(300);
  Calc_CompensatorZ(3000);
  //  Serial.begin(9600);
  //  Serial.print(AT+BAUD8);
  //  Serial.end();
  Serial.begin(115200);
  for (int i = 0; i < 20; i++)
  {
    delay(50); digitalWrite(S_DIOD, HIGH);
    delay(50); digitalWrite(S_DIOD, LOW);
  }
  stepcoder_setup();
  digitalWrite(S_DIOD, HIGH);
  flagStop = true;
  SumIntegral = 0;

}
//=================================================================
// Основная программа.
void loop()
{
  //  uint16_t alass;
  //  alass = 5000;
  if (flagStop) digitalWrite(EN, 0); // Включение
  int j = 0;
  int i = 0;
  unsigned long timer1 = micros();//Время приказа движения
  unsigned  long timer2;
  unsigned  long timer3, timer4;
  float  dt, dGyYsum, SumD = 0;
  char bt_input;
  float   _1_d_131 = 1.0 / 131.0;
  GyYsum = 0;
  float dGyYsumFilter = 0;
  dt = 0.005;//(timer - timer2) * 0.000001; // время действия скорости В секундах
  i = 0;
  SumIntegral = 0; GyYsumPID = 0;
  while (flagStop)
  {
    //===============================
    //Искуственная задержка
    timer2 = micros();
    while (timer2 - timer1 < 5000) timer2 = micros();
    //Запрос данных с MPU-6050
    //timer2 = timer;
    timer1 = timer2;

    Data_mpu6050();
    //Расчет угла по показаниям акселерометра
    // с учетом корректировки точки равновесия balancing_zerro.
    AcXsum = (atan2(AcX, AcZ)) * RAD_TO_DEG;
    // Измерение наклона по Х.
    // Использование Комплементарного фильтра,
    // alfa - коэффициент фильтра.
    //dt = (timer - timer2) * 0.000001; // время действия скорости В секундах
    dGyYsum = - (float(GyY) - CompensatorY)  * _1_d_131; // скорость угловая В градусах - падения
    // Комплементарный фильтр
    GyYsum = ONE_ALFA * (GyYsum + dGyYsum * dt) + ALFA * AcXsum;

    //===============================
    if (i > 19) //Корректируем положение робота каждые 0.1 сек
    {
      dGyYsumFilter = (GyYsum - dGyYsumFilter);// * 10.0; //Вычисляем реальную угловую скорость за период/изменение угла за 0.1 сек
      BT_input();  //    == ввод команд == == == == == == == == == == == == == == ==
      // берем среднюю скорость за исследуемый период
      step_command(GyYsum, dGyYsumFilter, move_speed, turn);
      dGyYsumFilter = GyYsum;
      i = 0;
      //      timer4=micros();
      //      Serial.println(timer4-timer3);
      //      timer3=timer4;
    }
    else
    {
      
    //  == Если робот упал =============================
      if (i == 10)
      {
        if ((GyYsum > 40.0) || (GyYsum < -40.0))
        {
          flagStop = false;    return;
        }
      }
    }
    i++;


    //=============================================
  }
  digitalWrite(EN, 1); // Пока отключен
  delay(1000);
  //flagStop = true;
}

